; ##############################################################################
; ##############################################################################
; ##############################################################################
BERECHNUNG:
;-------------------------------------------------------------------------------
; Dreht sich gerade der Motor ?													
	LDS temp,(adr_MOTOR_DREHRICHTUNG)
	tst temp
	breq BERECHNUNG_NO_BEWEGUNG
	ret
BERECHNUNG_NO_BEWEGUNG:
;-------------------------------------------------------------------------------
; Hat sich die SOLL-Temperatur gendert?										
	LDS temp1,(adr_TEMPERATUR_SOLL_L)
	LDS temp2,(adr_TEMPERATUR_SOLL_H)
	LDS temp3,(adr_TEMPERATUR_SOLL_OLD_L)
	LDS temp4,(adr_TEMPERATUR_SOLL_OLD_H)
	STS(adr_TEMPERATUR_SOLL_OLD_L),temp1
	STS(adr_TEMPERATUR_SOLL_OLD_H),temp2
	cp temp1,temp3
	brne BERECHNUNG_ACTION
	cp temp2,temp4
	brne BERECHNUNG_ACTION
;-------------------------------------------------------------------------------
; Timer ausgelst ?																
	LDS temp,(adr_TIMER_BERECHNUNG_mm)
	tst temp
	breq BERECHNUNG_ACTION
	ret
;-------------------------------------------------------------------------------
; Temperatur OFF (MIN=0C) ?													
BERECHNUNG_ACTION:
	call ADC_MESSEN_TEMPERATUR			; ADC
	call ADC_MESSEN_BATTERIE_SPANNUNG	; ADC

	ldi temp,(TIMERWERT_BERECHNUNG)		; Timerwert
	STS(adr_TIMER_BERECHNUNG_mm),temp
	LDS temp1,(adr_TEMPERATUR_SOLL_L)
	LDS temp2,(adr_TEMPERATUR_SOLL_H)	
	tst temp1
	brne BERECHNUNG_VOLL
	tst temp2
	brne BERECHNUNG_VOLL
	ldi temp1,0
	call MOTOR_PROZENT_TEMP1
	ret
;-------------------------------------------------------------------------------
; Temperatur ON (MAX=30C) ?													
BERECHNUNG_VOLL:
	LDS temp1,(adr_TEMPERATUR_SOLL_L)
	LDS temp2,(adr_TEMPERATUR_SOLL_H)	
	cpi temp1,LOW (TEMPERATUR_MAX)
	brne BERECHNUNG_RUN
	cpi temp2,HIGH(TEMPERATUR_MAX)
	brne BERECHNUNG_RUN
	ldi temp1,100
	call MOTOR_PROZENT_TEMP1
	ret
;-------------------------------------------------------------------------------
BERECHNUNG_RUN:
	LDS temp1,(adr_TEMPERATUR_IST_L)
	LDS temp2,(adr_TEMPERATUR_IST_H)	
	LDS temp3,(adr_TEMPERATUR_SOLL_L)	
	LDS temp4,(adr_TEMPERATUR_SOLL_H)
	cp temp2,temp4
	breq BERECHNUNG_L
	brsh BERECHNUNG_ZU_WARM
	brlo BERECHNUNG_ZU_KALT
BERECHNUNG_L:
	cp temp1,temp3
	breq BERECHNUNG_ZU_WARM
	brsh BERECHNUNG_ZU_WARM
	brlo BERECHNUNG_ZU_KALT
;-------------------------------------------------------------------------------
BERECHNUNG_ZU_WARM:
	ldi temp1,0
	call MOTOR_PROZENT_TEMP1
	ret
;-------------------------------------------------------------------------------
BERECHNUNG_ZU_KALT:
	LDS temp1,(adr_TEMPERATUR_SOLL_L)	 ; 21,0
	LDS temp2,(adr_TEMPERATUR_SOLL_H)
	LDS temp3,(adr_TEMPERATUR_IST_L)	 ; 20,0
	LDS temp4,(adr_TEMPERATUR_IST_H)	

	sub temp1,temp3
	sbc temp2,temp4						  ; 10

	LDS temp3,(adr_HZG_FAKTOR)			  ; mal 5
	clr temp4
	call FUNKTION_MULTIPLIKATION_16_16_32 ; =50%
	tst temp4
	brne BERECHNUNG_ZU_KALT_VOLLE_PULLE
	tst temp3
	brne BERECHNUNG_ZU_KALT_VOLLE_PULLE
	tst temp2
	brne BERECHNUNG_ZU_KALT_VOLLE_PULLE
	cpi temp1,(100+1); 100%
	brsh BERECHNUNG_ZU_KALT_VOLLE_PULLE
	call MOTOR_PROZENT_TEMP1
	ret
;-------------------------------------------------------------------------------
BERECHNUNG_ZU_KALT_VOLLE_PULLE:
	ldi temp1,100
	call MOTOR_PROZENT_TEMP1
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
HZG_SCHALTEN:
	call FUNCTION_HEIZZEITEN_LADEN

	LDS temp,(adr_ss)
	cpi temp,0
	breq HZG_SCHALTEN_w
	cpi temp,1
	breq HZG_SCHALTEN_w
	cpi temp,2
	breq HZG_SCHALTEN_w
	ret
;-------------------------------------------------------------------------------
; Entkalkung ?																	
HZG_SCHALTEN_w:
	LDS temp,(adr_WOCHENTAG)
	cpi temp,(5)	; Freitag	
	brne HZG_SCHALTEN_w2
	LDS temp,(adr_hh)
	cpi temp,(18)	; 18 Uhr	
	brne HZG_SCHALTEN_w2
	LDS temp,(adr_mm)
	cpi temp,(0)	; 0 Min		
	brne HZG_SCHALTEN_w2
	call TEXT_KALK
	call WAIT_1s
	ldi temp1,255	; auf		
	call MOTOR_PROZENT_TEMP1
	call MOTOR_WAIT
	call TEXT_KALK
	call WAIT_1s
	ldi temp1,0		; zu		
	call MOTOR_PROZENT_TEMP1
	call MOTOR_WAIT
	STS(adr_TEMPERATUR_SOLL_OLD_L),NULL
	STS(adr_TEMPERATUR_SOLL_OLD_H),NULL
;-------------------------------------------------------------------------------
; Modus manuell ?																
HZG_SCHALTEN_w2:
	LDS temp,(adr_MODUS_MANU_ON)
	tst temp
	breq PC+2
	ret
;-------------------------------------------------------------------------------
	LDS temp,(adr_mm)
	cpi temp,0
	breq HZG_SCHALTEN_RUN
	cpi temp,10
	breq HZG_SCHALTEN_RUN
	cpi temp,20
	breq HZG_SCHALTEN_RUN
	cpi temp,30
	breq HZG_SCHALTEN_RUN
	cpi temp,40
	breq HZG_SCHALTEN_RUN
	cpi temp,50
	breq HZG_SCHALTEN_RUN
	ret
;-------------------------------------------------------------------------------
HZG_SCHALTEN_RUN:
	call FUNCTION_ZEIT_CODIEREN_TEMP
	; zuerst die "ON" Zeiten		
	LDS temp1,(adr_MOMENTAN_ON1)
	cp temp1,temp
	breq HZG_TAG
	LDS temp1,(adr_MOMENTAN_ON2)
	cp temp1,temp
	breq HZG_TAG
	LDS temp1,(adr_MOMENTAN_ON3)
	cp temp1,temp
	breq HZG_TAG
;-------------------------------------------------------------------------------
	; OFF-Zeiten						
	LDS temp1,(adr_MOMENTAN_OFF1)
	cp temp1,temp
	breq HZG_NACHT
	LDS temp1,(adr_MOMENTAN_OFF2)
	cp temp1,temp
	breq HZG_NACHT
	LDS temp1,(adr_MOMENTAN_OFF3)
	cp temp1,temp
	breq HZG_NACHT
ret
;-------------------------------------------------------------------------------
HZG_TAG:
	STS(adr_MODUS_TAG_ON),EINS
	LDS temp1,(adr_TEMPERATUR_TAG_L)
	LDS temp2,(adr_TEMPERATUR_TAG_H)
	STS(adr_TEMPERATUR_SOLL_L),temp1
	STS(adr_TEMPERATUR_SOLL_H),temp2
	ret
;-------------------------------------------------------------------------------
HZG_NACHT:
	STS(adr_MODUS_TAG_ON),NULL
	LDS temp1,(adr_TEMPERATUR_NACHT_L)
	LDS temp2,(adr_TEMPERATUR_NACHT_H)
	STS(adr_TEMPERATUR_SOLL_L),temp1
	STS(adr_TEMPERATUR_SOLL_H),temp2
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################




