; ##############################################################################
; ##############################################################################
; ##############################################################################
; Version 10/2017																
;																				
; Ein Byte aus EEPROM holen und Z-Zeiger + 1									
;																				
; INPUT:	ZL Adresse (low)													
;			ZH Adresse (High)													
;																				
; OUTPUT: 	temp (DATEN)														
;																				
EEPROM_READ_PLUS_Z_TEMP:
	sbic EECR,EEWE 		; Wait for completion of previous write
	rjmp EEPROM_READ_PLUS_Z_TEMP
	out  EEARH, ZH		; ADRESSE setzen						
	out  EEARL, ZL
	sbi  EECR,EERE		; Start eeprom read by writing EERE		
	in 	 temp,EEDR		; Read data from data register			
	adiw ZL,1			; ADRESSE +1 							
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Version 10/2017																
;																				
; Ein Byte im EEPROM ablegen und Z-Zeiger + 1									
;																				
; INPUT:	ZL Adresse (low)													
;			ZH Adresse (High)													
; 		 	temp  DATEN															
;																				
EEPROM_WRITE_PLUS_Z_TEMP:
	mov R0,temp			; Kopie				
	rcall EEPROM_READ_PLUS_Z_TEMP
	cp R0,temp			; vergleich			
	brne EEPROM_WRITE_PLUS_RUN
	ret
;-------------------------------------------------------------------------------
EEPROM_WRITE_PLUS_RUN:
	mov temp,R0			; temp wieder herstellen	
	sbiw ZL,1			; ADRESSE -1 		
;-------------------------------------------------------------------------------
EEPROM_WRITE_PLUS_s:
	sbic EECR,EEWE		; Wait for completion of previous write
	rjmp EEPROM_WRITE_PLUS_Z_TEMP
	out  EEARH,ZH		; ADRESSE setzen						
	out  EEARL,ZL
	out  EEDR, temp		; Write data  to data register			
	sbi  EECR, EEMWE	; Write logical one to EEMWE			
	sbi  EECR, EEWE		; Start eeprom write by setting EEWE	
;-------------------------------------------------------------------------------
; Verify																		
	mov R0,temp
	rcall EEPROM_READ_PLUS_Z_TEMP
	cp R0,temp
	brne EEPROM_WRITE_PLUS_ERROR
	ret
;-------------------------------------------------------------------------------
EEPROM_WRITE_PLUS_ERROR:
	ldi temp1,(ERROR_EEPROM)
	rjmp ANZEIGE_ERROR_LEICHT_TEMP1
; ##############################################################################
; ##############################################################################
; ##############################################################################
EEPROM_KONFIGURATION_SPEICHERN:
	STS(adr_MENUE),NULL
	call TEXT_SAVE
	call WAIT_200ms
	ldi XL, LOW(adr_DATEN)
	ldi XH, HIGH(adr_DATEN)
	clr ZL
	clr ZH
;-------------------------------------------------------------------------------
	ldi temp9,(ANZAHL_EEPROM_BYTES)
EEPROM_KONFIGURATION_SPEICHERN_s:
	LD temp,X+
	rcall EEPROM_WRITE_PLUS_Z_TEMP
	dec temp9
	brne EEPROM_KONFIGURATION_SPEICHERN_s
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
EEPROM_KONFIGURATION_LADEN:
	call TASTATUR_ABFRAGE_TEMP
	tst temp	
	breq EEPROM_KONFIGURATION_LADEN_START
;-------------------------------------------------------------------------------
; WERKSEINSTELLUNG																
EEPROM_KONFIGURATION_WERK:
	ldi temp9,10
EEPROM_KONFIGURATION_WERK_s:
	call TEXT_WERK
	call WAIT_200ms
	call LCD_CLEAR
	call WAIT_200ms
	dec temp9
	brne EEPROM_KONFIGURATION_WERK_s
	ret
;-------------------------------------------------------------------------------
EEPROM_KONFIGURATION_LADEN_START:
	clr ZL
	clr ZH
	rcall EEPROM_READ_PLUS_Z_TEMP
	cpi temp,(EEPROM_WERKSEINSTELLUNG)	; WERKSEINSTELLUNG ?
	breq EEPROM_KONFIGURATION_LADEN_ACTION
	rjmp EEPROM_KONFIGURATION_WERK		; ja				
;-------------------------------------------------------------------------------
EEPROM_KONFIGURATION_LADEN_ACTION:
	clr ZL
	clr ZH
	ldi XL, LOW(adr_DATEN)
	ldi XH, HIGH(adr_DATEN)
	clr ZL
	clr ZH
	ldi temp9,(ANZAHL_EEPROM_BYTES)
EEPROM_KONFIGURATION_LADEN_s:
	rcall EEPROM_READ_PLUS_Z_TEMP
	ST X+,temp
	dec temp9
	brne EEPROM_KONFIGURATION_LADEN_s
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
