; ##############################################################################
; ##############################################################################
; ##############################################################################
MOTOR_INITIALISIERUNG:
	sbi (MOTOR_AUF_DDR),(MOTOR_AUF_PIN_NR)	; auf Ausgang	
	sbi (MOTOR_ZU_DDR) ,(MOTOR_ZU_PIN_NR)	; auf Ausgang	
	cbi (MOTOR_AUF_PORT),(MOTOR_AUF_PIN_NR)	; LOW			
	cbi (MOTOR_ZU_PORT) ,(MOTOR_ZU_PIN_NR)	; LOW			
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; bei ca. 1kHz piept er am lautesten :-)										
MOTOR_BEEP:
	push temp9
	ldi temp9,100
MOTOR_BEEP_s:
	WDR
	cbi (MOTOR_AUF_PORT),(MOTOR_AUF_PIN_NR)
	sbi (MOTOR_ZU_PORT) ,(MOTOR_ZU_PIN_NR)
	call WAIT_500us
	sbi (MOTOR_AUF_PORT),(MOTOR_AUF_PIN_NR)
	cbi (MOTOR_ZU_PORT) ,(MOTOR_ZU_PIN_NR)
	call WAIT_500us
	dec temp9
	brne MOTOR_BEEP_s
	cbi (MOTOR_AUF_PORT),(MOTOR_AUF_PIN_NR)
	cbi (MOTOR_ZU_PORT) ,(MOTOR_ZU_PIN_NR)
	pop temp9
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
MOTOR_BEEP_LANG:
	push temp9
	ldi temp9,255
MOTOR_BEEP_LANG_s:
	WDR
	cbi (MOTOR_AUF_PORT),(MOTOR_AUF_PIN_NR)
	sbi (MOTOR_ZU_PORT) ,(MOTOR_ZU_PIN_NR)
	call WAIT_500us
	sbi (MOTOR_AUF_PORT),(MOTOR_AUF_PIN_NR)
	cbi (MOTOR_ZU_PORT) ,(MOTOR_ZU_PIN_NR)
	call WAIT_500us
	dec temp9
	brne MOTOR_BEEP_LANG_s
	cbi (MOTOR_AUF_PORT),(MOTOR_AUF_PIN_NR)
	cbi (MOTOR_ZU_PORT) ,(MOTOR_ZU_PIN_NR)
	pop temp9
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
MOTOR_BEEP_SPEZIAL:
	ldi temp9,200
MOTOR_BEEPS_s:
	WDR
	cbi (MOTOR_AUF_PORT),(MOTOR_AUF_PIN_NR)
	sbi (MOTOR_ZU_PORT) ,(MOTOR_ZU_PIN_NR)
	call MOTOR_BEEP1_FREQUENZ
	sbi (MOTOR_AUF_PORT),(MOTOR_AUF_PIN_NR)
	cbi (MOTOR_ZU_PORT) ,(MOTOR_ZU_PIN_NR)
	call MOTOR_BEEP1_FREQUENZ
	dec temp9
	brne MOTOR_BEEPS_s
	cbi (MOTOR_AUF_PORT),(MOTOR_AUF_PIN_NR)
	cbi (MOTOR_ZU_PORT) ,(MOTOR_ZU_PIN_NR)
ret
;-------------------------------------------------------------------------------
MOTOR_BEEP1_FREQUENZ:
	mov temp,temp9
	cpi temp,100
	brsh MOTOR_BEEP1_FREQUENZ_s
	ldi temp,100
MOTOR_BEEP1_FREQUENZ_s:
	dec temp
	brne MOTOR_BEEP1_FREQUENZ_s
	ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Pull UPs aus, da REFLEXLICHTSCHRANKE nur wenig Strom schalten kann !			
MOTOR_REFLEXLICHTSCHRANKE_ON:
	STS(adr_MOTOR_REFLEXLICHTSCHRANKE_ON),EINS
	sbi (REFLEX_POWER_DDR) ,(REFLEX_POWER_PIN_NR)	; auf Ausgang	
	sbi (REFLEX_POWER_PORT) ,(REFLEX_POWER_PIN_NR)	; HIGH			
	cbi (REFLEX_DDR) ,(REFLEX_PIN_NR)				; auf EINGANG	
	cbi (REFLEX_PORT),(REFLEX_PIN_NR)				; Pull-UP aus !	
	call WAIT_50ms					; PAUSE, sonst ev. Fehlimpulse	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
MOTOR_REFLEXLICHTSCHRANKE_OFF:
	STS(adr_MOTOR_REFLEXLICHTSCHRANKE_ON),NULL
	cbi (REFLEX_POWER_DDR) ,(REFLEX_POWER_PIN_NR)	; auf EINGANG	
	cbi (REFLEX_POWER_PORT) ,(REFLEX_POWER_PIN_NR)	; Pull-UP aus	
	cbi (REFLEX_DDR) ,(REFLEX_PIN_NR)				; auf EINGANG	
	cbi (REFLEX_PORT),(REFLEX_PIN_NR)				; Pull-UP aus	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
MOTOR_AUF:
	call LCD_ANTENNE_ON
	call LCD_KOFFER_OFF
	cbi (MOTOR_AUF_PORT),(MOTOR_AUF_PIN_NR)	; LOW						
	cbi (MOTOR_ZU_PORT) ,(MOTOR_ZU_PIN_NR)	; LOW						
	call MOTOR_REFLEXLICHTSCHRANKE_ON		; REX ON					
	STS(adr_MOTOR_DREHRICHTUNG),EINS 		; (1)			
	sbi (MOTOR_AUF_PORT),(MOTOR_AUF_PIN_NR)	; HIGH			
	cbi (MOTOR_ZU_PORT) ,(MOTOR_ZU_PIN_NR)	; LOW			
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
MOTOR_ZU:
	cbi (MOTOR_AUF_PORT),(MOTOR_AUF_PIN_NR)	; LOW						
	cbi (MOTOR_ZU_PORT) ,(MOTOR_ZU_PIN_NR)	; LOW						
	call MOTOR_REFLEXLICHTSCHRANKE_ON		; REX ON					
	STS(adr_MOTOR_DREHRICHTUNG),VOLL		; (-1)			
	cbi (MOTOR_AUF_PORT),(MOTOR_AUF_PIN_NR)	; LOW			
	sbi (MOTOR_ZU_PORT) ,(MOTOR_ZU_PIN_NR)	; HIGH			
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; lst Laufzeitberwachung aus													
MOTOR_STOP:
	cbi (MOTOR_AUF_PORT),(MOTOR_AUF_PIN_NR)	; LOW						
	cbi (MOTOR_ZU_PORT) ,(MOTOR_ZU_PIN_NR)	; LOW						
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
MOTOR_POSITION_IST_TEMP1_2:
	cli 							;Global Interrupt Disable	
	LDS temp1,(adr_MOTOR_POSITION_IST_L)
	LDS temp2,(adr_MOTOR_POSITION_IST_H)
	sei 							; Global Interrupt Enable	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
MOTOR_WAIT:
	WDR
	call ANZEIGE_BARGRAPH_MOTOR_IST
	call ADC_MESSEN_BATTERIE_SPANNUNG
	call ANZEIGE_BATTERIESTATUS
	call TASTATUR_ABFRAGE_TEMP
	call MOTOR_POSITION_IST_TEMP1_2
	call LCD_ZAHL_TEMP1_2
	LDS temp,(adr_MOTOR_REFLEXLICHTSCHRANKE_ON)
	tst temp
	brne MOTOR_WAIT
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
MOTOR_POSITIONIEREN:
	ldi temp1,LOW (0)		; ist	
	ldi temp2,HIGH(0)
	STS(adr_MOTOR_POSITION_IST_L),temp1
	STS(adr_MOTOR_POSITION_IST_H),temp2
	ldi temp1,LOW (9000)	; soll	
	ldi temp2,HIGH(9000)
	STS(adr_MOTOR_POSITION_SOLL_L),temp1
	STS(adr_MOTOR_POSITION_SOLL_H),temp2
	call MOTOR_ENDANSCHLAG_AUF
	LDS temp1,(adr_MOTOR_POSITION_ENDE_L)
	LDS temp2,(adr_MOTOR_POSITION_ENDE_H)
	STS(adr_MOTOR_POSITION_IST_L),temp1
	STS(adr_MOTOR_POSITION_IST_H),temp2
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; "zu" bis Anschlag															
MOTOR_ENDANSCHLAG_ZU:
	call MOTOR_ZU
	call MOTOR_WAIT
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; "auf" bis Anschlag															
MOTOR_ENDANSCHLAG_AUF:
	call MOTOR_AUF
	call MOTOR_WAIT
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
MOTOR_CALIBRIERUNG:
	ldi temp1,LOW (0)		; ist	
	ldi temp2,HIGH(0)
	STS(adr_MOTOR_POSITION_IST_L),temp1
	STS(adr_MOTOR_POSITION_IST_H),temp2
	ldi temp1,LOW (900)	; soll	
	ldi temp2,HIGH(900)
	STS(adr_MOTOR_POSITION_SOLL_L),temp1
	STS(adr_MOTOR_POSITION_SOLL_H),temp2
	call MOTOR_ENDANSCHLAG_AUF
	call WAIT_1s
	call MOTOR_BEEP_SPEZIAL
	call WAIT_1s
;-------------------------------------------------------------------------------
	ldi temp1,LOW (900)
	ldi temp2,HIGH(900)
	STS(adr_MOTOR_POSITION_IST_L),temp1
	STS(adr_MOTOR_POSITION_IST_H),temp2
	ldi temp1,LOW (0)
	ldi temp2,HIGH(0)
	STS(adr_MOTOR_POSITION_SOLL_L),temp1
	STS(adr_MOTOR_POSITION_SOLL_H),temp2
	call MOTOR_ENDANSCHLAG_ZU
	call WAIT_1s
	call MOTOR_BEEP_SPEZIAL
	call WAIT_1s
	call MOTOR_BEEP_SPEZIAL
	call WAIT_1s
;-------------------------------------------------------------------------------
	ldi temp1,LOW (0)		; ist	
	ldi temp2,HIGH(0)
	STS(adr_MOTOR_POSITION_IST_L),temp1
	STS(adr_MOTOR_POSITION_IST_H),temp2
	ldi temp1,LOW (900)		; soll	
	ldi temp2,HIGH(900)
	STS(adr_MOTOR_POSITION_SOLL_L),temp1
	STS(adr_MOTOR_POSITION_SOLL_H),temp2
	call MOTOR_ENDANSCHLAG_AUF
	call MOTOR_POSITION_IST_TEMP1_2
	STS(adr_MOTOR_POSITION_ENDE_L),temp1
	STS(adr_MOTOR_POSITION_ENDE_H),temp2
	call WAIT_1s
	call MOTOR_BEEP_SPEZIAL
	call WAIT_1s
	call MOTOR_BEEP_SPEZIAL
	call WAIT_1s
	call MOTOR_BEEP_SPEZIAL
	call WAIT_1s
	jmp EEPROM_KONFIGURATION_SPEICHERN
; ##############################################################################
; ##############################################################################
; ##############################################################################
MOTOR_X:
	tst XH			; negativ ?	
	brpl MOTOR_X_ACTION
	ret
;-------------------------------------------------------------------------------
; nicht auf ENDE-POSITION, wegen Stromverbrauch									
MOTOR_X_ACTION:
	LDS temp1,(adr_MOTOR_POSITION_ENDE_L)
	LDS temp2,(adr_MOTOR_POSITION_ENDE_H)
	ldi temp,(10)	; -10
	sub temp1,temp
	sbc temp2,NULL

	cp XH,temp2
	breq MOTOR_X_L
	brsh MOTOR_X_BEGRENZUNG
	brlo MOTOR_X_START
MOTOR_X_L:
	cp XL,temp1
	breq MOTOR_X_START
	brsh MOTOR_X_BEGRENZUNG
	brlo MOTOR_X_START
;-------------------------------------------------------------------------------
MOTOR_X_BEGRENZUNG:
	mov XL,temp1
	mov Xh,temp2
;-------------------------------------------------------------------------------
MOTOR_X_START:
	STS(adr_MOTOR_POSITION_SOLL_L),XL
	STS(adr_MOTOR_POSITION_SOLL_H),XH
	rcall MOTOR_POSITION_IST_TEMP1_2	; Position	
;-------------------------------------------------------------------------------
	sub temp1,XL
	sbc temp2,XH
	tst temp2
	brpl MOTOR_X_w	; positiv	
	com temp1		; mal (-1)	
	com temp2
	add temp1,EINS
	adc temp2,NULL
MOTOR_X_w:
	tst temp2
	brne MOTOR_NACH_RUN
	cpi temp1,(MOTOR_GENAUIGKEIT)
	brsh MOTOR_NACH_RUN
ret
;-------------------------------------------------------------------------------
MOTOR_NACH_RUN:
	LDS XL,(adr_MOTOR_POSITION_SOLL_L)
	LDS XH,(adr_MOTOR_POSITION_SOLL_H)
	rcall MOTOR_POSITION_IST_TEMP1_2	; Position	
	cp XH,temp2
	breq MOTOR_POS_L
	brsh MOTOR_POS_AUF
	rjmp MOTOR_POS_ZU
MOTOR_POS_L:
	cp XL,temp1
	breq MOTOR_POS_FERTIG
	brsh MOTOR_POS_AUF
	rjmp MOTOR_POS_ZU
;-------------------------------------------------------------------------------
MOTOR_POS_FERTIG:
	ret
;-------------------------------------------------------------------------------
MOTOR_POS_AUF:
	rjmp MOTOR_AUF
;-------------------------------------------------------------------------------
MOTOR_POS_ZU:
	rjmp MOTOR_ZU
; ##############################################################################
; ##############################################################################
; ##############################################################################
MOTOR_PROZENT_TEMP1:
	LDS temp,(adr_MOTOR_REFLEXLICHTSCHRANKE_ON)
	tst temp
	breq MOTOR_PROZENT_RUN
	ret
;-------------------------------------------------------------------------------
MOTOR_PROZENT_RUN:
	STS(adr_MOTOR_PROZENT),temp1
	clr temp2
	LDS temp3,(adr_VENTIL_AUF_L)
	LDS temp4,(adr_VENTIL_AUF_H)
	LDS R0,(adr_VENTIL_ZU_L)
	LDS R1,(adr_VENTIL_ZU_H)
	sub temp3,R0
	sbc temp4,R1
	call FUNKTION_MULTIPLIKATION_16_16_32
	ldi temp5,LOW (100)
	ldi temp6,HIGH(100)
	call FUNKTION_DIVISION_32_16
	LDS R0,(adr_VENTIL_ZU_L)
	LDS R1,(adr_VENTIL_ZU_H)
	add temp1,R0
	adc temp2,R1
	mov XL,temp1
	mov XH,temp2
	call MOTOR_X
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
