; ##############################################################################
; ##############################################################################
; ##############################################################################
; CS02 CS01 CS00 Description													
; 0 0 0 No clock source (timer/counter stopped)									
; 0 0 1 clkI/O/(no prescaling)													
;*0 1 0 clkI/O/8 (from prescaler)												
; 0 1 1 clkI/O/64 (from prescaler)												
; 1 0 0 clkI/O/256 (from prescaler)												
; 1 0 1 clkI/O/1024 (from prescaler)											
; 1 1 0 External clock source on T0 pin. Clock on falling edge.					
; 1 1 1 External clock source on T0 pin. Clock on rising edge.					
TIMER0_INITIALISIEREN:
	ldi temp,(1<<TOIE0)
	STS(TIMSK0),temp
	ldi temp,(0<<CS02)|(1<<CS01) |(0<<CS00) 
	OUT(TCCR0A),temp
;	ldi temp,127
;	OUT(TCNT0),temp
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; 2ms																			
TIM0_OVF:
	in KOPIE_SREG,SREG			; SREG sichern					
	movw KOPIE_temp,temp		; temp + temp1 sichern (movw) 	
	movw KOPIE_XL,XL			; XL + XH sichern      (movw) 	
; ------------------------------------------------------------------------------
; MOTOR-DREHRICHTUNG															
; ------------------------------------------------------------------------------
	LDS temp,(adr_MOTOR_DREHRICHTUNG)	; Drehrichtung	
	cpi temp,0							; Motor steht	
	breq TIM0_OVF_0
	cpi temp,1							; Motor auf		
	breq TIM0_OVF_1
	rjmp TIM0_OVF_255
TIM0_OVF_0:
	call LCD_SAVE_OFF					; Symbol off	
	call LCD_ANTENNE_OFF				; Symbol off	
	rjmp TIM0_OVF_DREH_FERTIG
TIM0_OVF_1:
	call LCD_SAVE_OFF					; Symbol off	
	call LCD_ANTENNE_ON					; Symbol on		
	rjmp TIM0_OVF_DREH_FERTIG
TIM0_OVF_255:
	call LCD_SAVE_ON					; Symbol on		
	call LCD_ANTENNE_OFF				; Symbol off	
TIM0_OVF_DREH_FERTIG:		
; ------------------------------------------------------------------------------
; MOTOR-LAUFZEIT																
; ------------------------------------------------------------------------------
	LDS temp,(adr_MOTOR_DREHRICHTUNG)	; Drehrichtung	
	tst temp			
	breq TIM0_OVF_MOTOR_STEHT			; Motor steht	
	dec LAUFZ							; -1			
	tst LAUFZ							; Null ?		
	brne TIM0_OVF_MOTOR_IN_BEWEGUNG		; nein			
; ------------------------------------------------------------------------------
; MOTOR-LAUFZEIT berschritten, alles STOP !!!									
	STS(adr_MOTOR_DREHRICHTUNG),NULL	
	call MOTOR_STOP						; STOP			
	call MOTOR_REFLEXLICHTSCHRANKE_OFF	; REX off		
TIM0_OVF_MOTOR_STEHT:
	mov LAUFZ,VOLL						; Laufeit Refresh
TIM0_OVF_MOTOR_IN_BEWEGUNG:
; ------------------------------------------------------------------------------
; DREHGEBER																		
; ------------------------------------------------------------------------------
; Kanal-A-B abfragen															
	SEC  								; Set Carry		
	sbis (DREH_A_PIN),(DREH_A_PIN_NR)	; springe, wenn BIT(PIN) high	
	CLC  								; Clear Carry	
	ROL DREHGEBER_ROHBITS				; links Carry	
	SEC  								; Set Carry		
	sbis (DREH_B_PIN),(DREH_B_PIN_NR)	; springe, wenn BIT(PIN) high	
	CLC  								; Clear Carry	
	ROL DREHGEBER_ROHBITS				; links Carry	
; ------------------------------------------------------------------------------
	mov temp,DREHGEBER_ROHBITS
	cpi temp,0b00000000	; 0x00
	breq TIM0_DREH_OK
	cpi temp,0b10101010	; 0XAA
	breq TIM0_DREH_OK
	cpi temp,0b01010101	; 0x55
	breq TIM0_DREH_OK
	cpi temp,0b11111111	; 0xFF
	breq TIM0_DREH_OK
	rjmp TIM0_DREH_FERTIG
; ------------------------------------------------------------------------------
TIM0_DREH_OK:
	cp DREHGEBER_ROHBITS,DREHGEBER_WERT_OLD	; Vergleich	
	breq TIM0_DREH_FERTIG
; ------------------------------------------------------------------------------
	mov DREHGEBER_WERT_OLD,DREHGEBER_ROHBITS
	LSR DREHGEBER_ROHBITS	; C kullert raus	
	ROL DREHGEBER_BITMUSTER ; C reinscheiben	
	LSR DREHGEBER_ROHBITS	; C kullert raus	
	ROL DREHGEBER_BITMUSTER ; C reinscheiben	
	mov temp,DREHGEBER_BITMUSTER
	andi temp,0b00111111	; begrenzen			
	cpi temp,0x0B
	breq TIM0_OVF_RICHTUNG_1
	cpi temp,0x34
	breq TIM0_OVF_RICHTUNG_1
	cpi  temp,0x07
	breq TIM0_OVF_RICHTUNG_2
	cpi  temp,0x38
	breq TIM0_OVF_RICHTUNG_2
	rjmp TIM0_DREH_FERTIG
; ------------------------------------------------------------------------------
TIM0_OVF_RICHTUNG_1:
	STS(adr_DREHGEBER_WERT),EINS
	rjmp TIM0_DREH_FERTIG
TIM0_OVF_RICHTUNG_2:
	STS(adr_DREHGEBER_WERT),VOLL
TIM0_DREH_FERTIG:
; ------------------------------------------------------------------------------
; MOTOR																			
; ------------------------------------------------------------------------------
;.equ MOTOR_ABTASTUNG= 0b00001111	; langsamer Motor							
;.equ MOTOR_ABTASTUNG= 0b00000011	; schneller	Motor							
.equ MOTOR_ABTASTUNG= 0b00000111	; Empfehlung								
	SEC  							; Set Carry
	sbis (REFLEX_PIN) ,(REFLEX_PIN_NR)	; Skip if Bit in I/O Register is Set	
	CLC  							; Clear Carry	
	ROL MOTOR_ROHBITS				; C reinschieben
	mov temp,MOTOR_ROHBITS			; Kopie			
	andi temp,(MOTOR_ABTASTUNG)		; Bitmuster		
	cpi  temp,0b00000000			; NULL ?		
	breq TIM0_MOTOR_OK				; OK			
	cpi  temp,(MOTOR_ABTASTUNG)		; Bitmuster	?	
	breq TIM0_MOTOR_OK				; OK			
	rjmp TIM0_MOTOR_FERTIG
; ------------------------------------------------------------------------------
; ------------------------------------------------------------------------------
; ------------------------------------------------------------------------------
TIM0_MOTOR_OK:
	cp temp,MOTOR_WERT_OLD			; vergleich old	
	breq TIM0_MOTOR_FERTIG			; keine nderug	
; ------------------------------------------------------------------------------
; Impulse werden erkannt (auch Fehlimpulse)										
	mov MOTOR_WERT_OLD,temp			; old save		
	LDS temp,(adr_MOTOR_DREHRICHTUNG); Drehrichtung	
	cpi temp,(0)					; Sillstand ?	
	breq TIM0_MOTOR_FERTIG
; ------------------------------------------------------------------------------
; Laufzeit Refresh																
	mov LAUFZ,VOLL					; Laufeit volle Pulle !
; ------------------------------------------------------------------------------
; gltige Impulse																
	cpi temp, (1)					; auf ?		
	breq TIM0_MOTOR_AUF
	cpi temp,(-1)					; zu ?		
	breq TIM0_MOTOR_ZU
	ldi temp1,(ERROR_MOTOR)
	jmp ANZEIGE_ERROR_SCHWER_TEMP1
; ------------------------------------------------------------------------------
; Impulse Motor fhrt zu														
TIM0_MOTOR_ZU:
	LDS XL,(adr_MOTOR_POSITION_IST_L)	; laden		
	LDS XH,(adr_MOTOR_POSITION_IST_H)
	sbiw XL,1							; -1		
	tst XH								; berlauf ?
	brpl TIM0_MOTOR_BERECHNUNG
	clr XL								; NULL		
	clr XH
	rjmp TIM0_MOTOR_BERECHNUNG
; ------------------------------------------------------------------------------
; Impulse Motor fhrt auf														
TIM0_MOTOR_AUF:
	LDS XL,(adr_MOTOR_POSITION_IST_L)	; laden		
	LDS XH,(adr_MOTOR_POSITION_IST_H)
	cpi XL,255							; berlauf ?
	brne TIM0_MOTOR_w
	cpi XH,255							; berlauf ?
 	breq TIM0_MOTOR_BERECHNUNG
TIM0_MOTOR_w:
	adiw XL,1							; +1		
; ------------------------------------------------------------------------------
; Ziel erreicht ?																
TIM0_MOTOR_BERECHNUNG:
	STS(adr_MOTOR_POSITION_IST_L),XL	; speichern	
	STS(adr_MOTOR_POSITION_IST_H),XH
	LDS temp ,(adr_MOTOR_POSITION_SOLL_L); laden	
	LDS temp1,(adr_MOTOR_POSITION_SOLL_H)
; ------------------------------------------------------------------------------
	sub XL,temp
	sbc XH,temp1
	tst XH
	brpl TIM0_MOTOR_w1
	com XL
	com XH
	adiw XL,1
TIM0_MOTOR_w1:
	tst XH
	brne TIM0_MOTOR_FERTIG
	cpi XL,(MOTOR_NACHLAUF)
	breq TIM0_MOTOR_STOP
	brsh TIM0_MOTOR_FERTIG
; ------------------------------------------------------------------------------
; Jaaaa.... hurra  Motor STOP													
TIM0_MOTOR_STOP:
	mov LAUFZ,NULL							; Laufeit volle Pulle !
	call MOTOR_STOP
; ------------------------------------------------------------------------------
TIM0_MOTOR_FERTIG:
	out	SREG,KOPIE_SREG						; SREG			
	movw temp ,KOPIE_TEMP					; temp + temp1	
	movw XL,KOPIE_XL						; XL + XH 		
reti
; ##############################################################################
; ##############################################################################
; ##############################################################################
;CS22 CS21 CS20 																
; 0 0 0 No clock source (timer/counter stopped).								
; 0 0 1 clkT2S/(no prescaling)													
; 0 1 0 clkT2S/8 (from prescaler)												
; 0 1 1 clkT2S/32 (from prescaler)												
; 1 0 0 clkT2S/64 (from prescaler)												
;*1 0 1 clkT2S/128 (from prescaler)												
; 1 1 0 clkT2S/256 (from prescaler)												
; 1 1 1 clkT2S/1024 (from prescaler)											
; 1s / 32.768 Hz																
TIMER2_INITIALISIEREN:
	ldi temp,(1<<TOIE2)
	STS(TIMSK2),temp
	ldi temp,(1<<CS22)|(0<<CS21) |(1<<CS20) 
;	ldi temp,(0<<CS22)|(0<<CS21) |(1<<CS20)	; (no prescaling)
	STS(TCCR2A),temp
	ldi temp, (1<<AS2)	; Asynchronmodus 32kHz Quarz
	STS(ASSR),temp
;	ldi temp, TIMERWERT2; TIMER2 Startwert		
;	STS(TCNT2),temp
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; 1s / 32.768 Hz																
TIM2_OVF: 
	push TEMP		    ; Sichern von "TEMP" im Stack
	in	 TEMP,SREG		; Einlesen des SREG 
	push TEMP	    	; Schreiben von  SREG  im Stack (KOPIE)
	push temp1
; ##############################################################################
; Sekunden																		
	LDS temp,(adr_TIMER_SLEEP)	; TIMER	SLEEP
	tst temp
	breq PC+2
	dec temp
	STS(adr_TIMER_SLEEP),temp

	STS(adr_FREIGABE_ss),EINS	; Freigabe	
	LDS temp,(adr_ss)			; Sekunden	
	inc temp
	STS(adr_ss),temp
	cpi temp,(59+1)				;0..59		
	brlo TIM2_OVF_FERTIG 		;--> fertig	
	STS(adr_ss),NULL
; ##############################################################################
; Minuten																		
	LDS temp,(adr_TIMER_BERECHNUNG_mm)	; TIMER	BERECHNUNG
	tst temp
	breq PC+2
	dec temp
	STS(adr_TIMER_BERECHNUNG_mm),temp

	STS(adr_FREIGABE_mm),EINS	; Freigabe	
	LDS temp,(adr_mm)			; Minuten	
	inc temp
	STS(adr_mm),temp
	cpi temp,(59+1)				;0..59		
	brlo TIM2_OVF_FERTIG 		;--> fertig	
	STS(adr_mm),NULL
; ##############################################################################
; Stunden																		
	LDS temp,(adr_hh)			; Stunden	
	inc temp
	STS(adr_hh),temp
	cpi temp,(23+1)				; 0..23		
	brlo TIM2_OVF_FERTIG 		;--> fertig	
	STS(adr_hh),NULL
; ##############################################################################
; TAGE																			
	LDS temp ,(adr_TEMPERATUR_NACHT_L)
	LDS temp1,(adr_TEMPERATUR_NACHT_H)
	STS(adr_TEMPERATUR_SOLL_L),temp
	STS(adr_TEMPERATUR_SOLL_H),temp1
	STS(adr_MENUE),NULL			; vorsichtshalber auf NULL

	LDS temp,(adr_WOCHENTAG)	; WOCHENTAG	
	inc temp
	STS(adr_WOCHENTAG),temp
	cpi temp,7+1				;1..7		
	brlo TIM2_OVF_FERTIG 		;--> fertig	
	ldi temp,1					;1=Mo		
	STS(adr_WOCHENTAG),temp
; ------------------------------------------------------------------------------
TIM2_OVF_FERTIG: 
	pop temp1
	pop	TEMP					; LESEN von SREG vom STACK (KOPIE)
	out	SREG,TEMP				; Wiederherstellen von SREG
	pop	TEMP					; Wiederherstellen von "TEMP" 	
reti
; ##############################################################################
; ##############################################################################
; ##############################################################################

