;												
; Heikrperregler SilverCrest Bluethooth		
; ATmega169										
; Bernhard.Erfurt@gmx.de						
; 12/2017										
;												
;												


; ATmega169										
.include "m169def.inc"
;												
.equ TAKT					= 1000000	;  1 MHz		
.equ U_VBG					= 110		; 1,1V			
.equ EEPROM_WERKSEINSTELLUNG= 's'
.equ TIMERWERT_SLEEP		= 120		; 120=Sekunden	
.equ TIMERWERT_BERECHNUNG	= 3			; 3=3 Minuten	
.equ TEMPERATUR_MAX			= 300		; 30C			
.equ BATTERIE_LOW			= 220
.equ MOTOR_POSITION_ENDE	= 614 
.equ MOTOR_NACHLAUF			= 2
.equ MOTOR_GENAUIGKEIT		= 10
.equ HZG_FAKTOR				= 5 		;(Prozent pro 0,1 Abweichung)
.equ VENTIL_ZU				= 100
.equ VENTIL_AUF				= 300
; EEPROM										
.equ ANZAHL_EEPROM_BYTES	= 100
; ERROR-CODES									
.equ ERROR_INTERRUT			= 0xE0	; schwer	
.equ ERROR_PROGRAMM			= 0xE1	; schwer	
.equ ERROR_MOTOR			= 0xE2	; schwer	
.equ ERROR_EEPROM			= 0xEE	; leicht	
; LED											
.equ LED_PIN_NR				= 1
.equ LED_PIN				= PINB
.equ LED_DDR				= DDRB
.equ LED_PORT				= PORTB
; MOTOR-ZU										
.equ MOTOR_ZU_PIN_NR		= 6
.equ MOTOR_ZU_PIN			= PINE
.equ MOTOR_ZU_DDR			= DDRE
.equ MOTOR_ZU_PORT			= PORTE
; MOTOR-AUF										
.equ MOTOR_AUF_PIN_NR		= 7
.equ MOTOR_AUF_PIN			= PINE
.equ MOTOR_AUF_DDR			= DDRE
.equ MOTOR_AUF_PORT			= PORTE
; WIDERSTAND (120k fr Sensor)				
.equ WIDERSTAND_PIN_NR		= 3
.equ WIDERSTAND_DDR			= DDRF
.equ WIDERSTAND_PORT		= PORTF
; TASTE "MENUE"								
.equ TASTE_MENUE_WERT		= 1
.equ TASTE_MENUE_PIN_NR		= 4
.equ TASTE_MENUE_PIN		= PINB
.equ TASTE_MENUE_DDR		= DDRB
.equ TASTE_MENUE_PORT		= PORTB
; TASTE "OK"								
.equ TASTE_OK_WERT			= 2
.equ TASTE_OK_PIN_NR		= 6
.equ TASTE_OK_PIN			= PINB
.equ TASTE_OK_DDR			= DDRB
.equ TASTE_OK_PORT			= PORTB
; TASTE "TIME"						
.equ TASTE_TIME_WERT		= 4
.equ TASTE_TIME_PIN_NR		= 5
.equ TASTE_TIME_PIN			= PINB
.equ TASTE_TIME_DDR			= DDRB
.equ TASTE_TIME_PORT		= PORTB
; DREHGEBER									
.equ DREH_A_PIN_NR			= 0
.equ DREH_A_PIN				= PINB
.equ DREH_A_DDR				= DDRB
.equ DREH_A_PORT			= PORTB
; DREHGEBER									
.equ DREH_B_PIN_NR			= 7
.equ DREH_B_PIN				= PINB
.equ DREH_B_DDR				= DDRB
.equ DREH_B_PORT			= PORTB
; REFLEXLICHTSCHRANKE (Input)				
.equ REFLEX_PIN_NR			= 3
.equ REFLEX_PIN				= PINE
.equ REFLEX_DDR				= DDRE
.equ REFLEX_PORT			= PORTE
; REFLEXLICHTSCHRANKE (Power)				
.equ REFLEX_POWER_PIN_NR	= 2
.equ REFLEX_POWER_DDR		= DDRE
.equ REFLEX_POWER_PORT		= PORTE
; REGISTER									

.def LAUFZ				= R2	; Motor Laufzeit	
.def KOPIE_SREG			= R3
.def KOPIE_TEMP			= R4
.def KOPIE_TEMP1		= R5
.def KOPIE_XL			= R6
.def KOPIE_XH			= R7
.def MOTOR_ROHBITS		= R8
.def MOTOR_WERT_OLD		= R9
.def DREHGEBER_ROHBITS	= R10
.def DREHGEBER_WERT_OLD	= R11
.def DREHGEBER_BITMUSTER= R12
.def NULL	 			= R13
.def EINS 				= R14
.def VOLL				= R15
.def temp	 			= R16
.def temp1 				= R17
.def temp2 				= R18
.def temp3	 			= R19
.def temp4 				= R20
.def temp5 				= R21
.def temp6 				= R22
.def temp7 				= R23
.def temp8 				= R24
.def temp9 				= R25
; SRAM-BELEGUNG (dier ersten 100Byte werden im EEPROM gespeichert)
.equ adr_DATEN						=SRAM_START+0		; SRAM START Adresse 		
.equ adr_WERKSEINSTELLUNG			=SRAM_START+0

.equ adr_MODUS_MANU_ON				=SRAM_START+6	; 0=AUTOMATIC 1=MANU 	

.equ adr_HZG_FAKTOR					=SRAM_START+8	; Prozent pro 0,1 Abweichung

.equ adr_TEMPERATUR_TAG_L			=SRAM_START+12
.equ adr_TEMPERATUR_TAG_H			=SRAM_START+13
.equ adr_TEMPERATUR_NACHT_L			=SRAM_START+14
.equ adr_TEMPERATUR_NACHT_H			=SRAM_START+15

.equ adr_TEMPERATUR_IST_OFFSET		=SRAM_START+16	; TEMPERATUR-IST-Offset		

.equ adr_TEMPERATUR_SOLL_L			=SRAM_START+18	; SOLL_Temperatur	
.equ adr_TEMPERATUR_SOLL_H			=SRAM_START+19

.equ adr_MOTOR_POSITION_ENDE_L		=SRAM_START+22	; Ventil VOLL auf
.equ adr_MOTOR_POSITION_ENDE_H		=SRAM_START+23

.equ adr_VENTIL_ZU_L				=SRAM_START+26	; Ventil zu		
.equ adr_VENTIL_ZU_H				=SRAM_START+27

.equ adr_VENTIL_AUF_L				=SRAM_START+28	; Ventil auf	
.equ adr_VENTIL_AUF_H				=SRAM_START+29

.equ adr_TAG1_ON1					=SRAM_START+50 
.equ adr_TAG1_OFF1					=SRAM_START+51 
.equ adr_TAG1_ON2					=SRAM_START+52 
.equ adr_TAG1_OFF2					=SRAM_START+53 
.equ adr_TAG1_ON3					=SRAM_START+54 
.equ adr_TAG1_OFF3					=SRAM_START+55 
.equ adr_TAG2_ON1					=SRAM_START+56 ; TAG-2
.equ adr_TAG2_OFF1					=SRAM_START+57
.equ adr_TAG2_ON2					=SRAM_START+58
.equ adr_TAG2_OFF2					=SRAM_START+59
.equ adr_TAG2_ON3					=SRAM_START+60
.equ adr_TAG2_OFF3					=SRAM_START+61
.equ adr_TAG3_ON1					=SRAM_START+62 ; TAG-3
.equ adr_TAG3_OFF1					=SRAM_START+63
.equ adr_TAG3_ON2					=SRAM_START+64
.equ adr_TAG3_OFF2					=SRAM_START+65
.equ adr_TAG3_ON3					=SRAM_START+66
.equ adr_TAG3_OFF3					=SRAM_START+67
.equ adr_TAG4_ON1					=SRAM_START+68; TAG-4
.equ adr_TAG4_OFF1					=SRAM_START+69
.equ adr_TAG4_ON2					=SRAM_START+70
.equ adr_TAG4_OFF2					=SRAM_START+71
.equ adr_TAG4_ON3					=SRAM_START+72
.equ adr_TAG4_OFF3					=SRAM_START+73
.equ adr_TAG5_ON1					=SRAM_START+74; TAG-5
.equ adr_TAG5_OFF1					=SRAM_START+75
.equ adr_TAG5_ON2					=SRAM_START+76
.equ adr_TAG5_OFF2					=SRAM_START+77
.equ adr_TAG5_ON3					=SRAM_START+78
.equ adr_TAG5_OFF3					=SRAM_START+79
.equ adr_TAG6_ON1					=SRAM_START+80 ; TAG-6
.equ adr_TAG6_OFF1					=SRAM_START+81
.equ adr_TAG6_ON2					=SRAM_START+82
.equ adr_TAG6_OFF2					=SRAM_START+83
.equ adr_TAG6_ON3					=SRAM_START+84
.equ adr_TAG6_OFF3					=SRAM_START+85
.equ adr_TAG7_ON1					=SRAM_START+86 ; TAG-7
.equ adr_TAG7_OFF1					=SRAM_START+87
.equ adr_TAG7_ON2					=SRAM_START+88
.equ adr_TAG7_OFF2					=SRAM_START+89
.equ adr_TAG7_ON3					=SRAM_START+90
.equ adr_TAG7_OFF3					=SRAM_START+91
;-------------------------------------------------------------------------------
.equ adr_ss							=SRAM_START+100	; Sekunden					
.equ adr_mm							=SRAM_START+101	; Minuten					
.equ adr_hh							=SRAM_START+102	; Stunden					
.equ adr_WOCHENTAG					=SRAM_START+103	; Wochentag (1=Mo 7=So)		

.equ adr_FREIGABE_ss				=SRAM_START+106
.equ adr_FREIGABE_mm				=SRAM_START+107

.equ adr_TIMER_BOOST_L				=SRAM_START+110
.equ adr_TIMER_BOOST_H				=SRAM_START+111
.equ adr_TIMER_SLEEP				=SRAM_START+112
.equ adr_TIMER_BERECHNUNG_mm		=SRAM_START+113	; Minuten

.equ adr_MENUE						=SRAM_START+120
.equ adr_TASTE						=SRAM_START+121
.equ adr_TASTE_OLD					=SRAM_START+122
.equ adr_DREHGEBER_OLD				=SRAM_START+124

.equ adr_DREHGEBER_WERT				=SRAM_START+130	; (0=NIX) (1=Richtung_1) (255=Richtung_2)	
.equ adr_ZEITPROGRAMM_GRUPPE		=SRAM_START+131 ; fr Programmierung Heizzeiten				


.equ adr_MODUS_TAG_ON				=SRAM_START+133	; 0=NACHT 1=TAG			

.equ adr_TESTWERT_L					=SRAM_START+140
.equ adr_TESTWERT_H					=SRAM_START+141


.equ adr_MOTOR_DREHRICHTUNG			=SRAM_START+180
.equ adr_MOTOR_PROZENT				=SRAM_START+181
.equ adr_MOTOR_POSITION_IST_L		=SRAM_START+182
.equ adr_MOTOR_POSITION_IST_H		=SRAM_START+183
.equ adr_MOTOR_POSITION_SOLL_L		=SRAM_START+184
.equ adr_MOTOR_POSITION_SOLL_H		=SRAM_START+185
.equ adr_MOTORHAND_L				=SRAM_START+186
.equ adr_MOTORHAND_H				=SRAM_START+187
.equ adr_MOTOR_REFLEXLICHTSCHRANKE_ON=SRAM_START+188; 0=off 1=on		


.equ adr_TEMPERATUR_SOLL_OLD_L		=SRAM_START+192	; SOLL_Temperatur	
.equ adr_TEMPERATUR_SOLL_OLD_H		=SRAM_START+193

.equ adr_TEMPERATUR_IST_L			=SRAM_START+194	; IST_Temperatur	
.equ adr_TEMPERATUR_IST_H			=SRAM_START+195
.equ adr_TEMPERATUR_IST_SYSOFFS_L	=SRAM_START+196	; System-Offset		
.equ adr_TEMPERATUR_IST_SYSOFFS_H	=SRAM_START+197
.equ adr_TEMPERATUR_IST_SYSSTEIGUNG_L=SRAM_START+198; System-Steigung	
.equ adr_TEMPERATUR_IST_SYSSTEIGUNG_H=SRAM_START+199

.equ adr_MOMENTAN_ON1				=SRAM_START+200 ; ON- 1.Schaltpunkt	
.equ adr_MOMENTAN_OFF1				=SRAM_START+201 ; OFF-1.Schaltpunkt	
.equ adr_MOMENTAN_ON2				=SRAM_START+202 ; ON- 2.Schaltpunkt	
.equ adr_MOMENTAN_OFF2				=SRAM_START+203 ; OFF-2.Schaltpunkt	
.equ adr_MOMENTAN_ON3				=SRAM_START+204 ; ON- 3.Schaltpunkt	
.equ adr_MOMENTAN_OFF3				=SRAM_START+205 ; OFF-3.Schaltpunkt	

.equ adr_LCD0						=SRAM_START+240	; LCD-DIGIT-0 
.equ adr_LCD1						=SRAM_START+241	; LCD-DIGIT-1 
.equ adr_LCD2						=SRAM_START+242	; LCD-DIGIT-2 
.equ adr_LCD3						=SRAM_START+243	; LCD-DIGIT-3 

.equ adr_LCD0H						=SRAM_START+244	; LCD-DIGIT-0 
.equ adr_LCD1H						=SRAM_START+245	; LCD-DIGIT-1 
.equ adr_LCD2H						=SRAM_START+246	; LCD-DIGIT-2 
.equ adr_LCD3H						=SRAM_START+247	; LCD-DIGIT-3 


.equ adr_ADC_0_L					=SRAM_START+250
.equ adr_ADC_0_H					=SRAM_START+251
.equ adr_ADC_1_L					=SRAM_START+252
.equ adr_ADC_1_H					=SRAM_START+253
.equ adr_ADC_2_L					=SRAM_START+254
.equ adr_ADC_2_H					=SRAM_START+255
.equ adr_ADC_3_L					=SRAM_START+256
.equ adr_ADC_3_H					=SRAM_START+257
.equ adr_ADC_4_L					=SRAM_START+258
.equ adr_ADC_4_H					=SRAM_START+259
.equ adr_ADC_5_L					=SRAM_START+260
.equ adr_ADC_5_H					=SRAM_START+261
.equ adr_ADC_6_L					=SRAM_START+262
.equ adr_ADC_6_H					=SRAM_START+263
.equ adr_ADC_7_L					=SRAM_START+264
.equ adr_ADC_7_H					=SRAM_START+265
.equ adr_ADC_VBG_L					=SRAM_START+266
.equ adr_ADC_VBG_H					=SRAM_START+267
.equ adr_ADC_BATTERIE_L				=SRAM_START+268
.equ adr_ADC_BATTERIE_H				=SRAM_START+269

.equ adr_HISTORIE_ZEIGER			=SRAM_START+300
.equ adr_HISTORIE_L					=SRAM_START+301
.equ adr_HISTORIE_H					=SRAM_START+302

.equ adr_SRAM_CHECK					=SRAM_START+943	; SRAM CHECK muss immer "S" sein




.cseg							;Beginn eines Code-Segmentes						
.org 0							;Startadresse=0										
.org 0x0000 jmp RESET 			; Reset Handler										
.org 0x0002 jmp INTERRUPT_ERROR ; jmp EXT_INT0 	; IRQ0 Handler						
.org 0x0004 jmp INTERRUPT_ERROR ; jmp PCINT0 		; PCINT0 Handler				
.org 0x0006 jmp INTERRUPT_ERROR ; jmp PCINT1 		; PCINT0 Handler				
.org 0x0008 jmp INTERRUPT_ERROR ; jmp TIM2_COMP 	; Timer2 Compare Handler		
.org 0x000A jmp TIM2_OVF 	; Timer2 Overflow Handler								
.org 0x000C jmp INTERRUPT_ERROR ; jmp TIM1_CAPT 	; Timer1 Capture Handler		
.org 0x000E jmp INTERRUPT_ERROR ; jmp TIM1_COMPA 	; Timer1 CompareA Handler		
.org 0x0010 jmp INTERRUPT_ERROR ; jmp TIM1_COMPB 	; Timer1 CompareB Handler		
.org 0x0012 jmp INTERRUPT_ERROR ; jmp TIM1_OVF 	; Timer1 Overflow Handler			
.org 0x0014 jmp INTERRUPT_ERROR ; jmp TIM0_COMP 	; Timer0 Compare Handler		
.org 0x0016 jmp TIM0_OVF 	; Timer0 Overflow Handler								
.org 0x0018 jmp INTERRUPT_ERROR ; jmp SPI_STC 	; SPI Transfer Complete Handler		
.org 0x001A jmp INTERRUPT_ERROR ; jmp USART_RXCn 	; USART0 RX Complete Handler	
.org 0x001C jmp INTERRUPT_ERROR ; jmp USART_DRE 	; USART0,UDRn Empty Handler		
.org 0x001E jmp INTERRUPT_ERROR ; jmp USART_TXCn 	; USART0 TX Complete Handler	
.org 0x0020 jmp INTERRUPT_ERROR ; jmp USI_STRT 	; USI Start Condition Handler		
.org 0x0022 jmp INTERRUPT_ERROR ; jmp USI_OVFL 	; USI Overflow Handler				
.org 0x0024 jmp INTERRUPT_ERROR ; jmp ANA_COMP 	; Analog Comparator Handler			
.org 0x0026 jmp INTERRUPT_ERROR ; jmp ADC 		; ADC Conversion Complete Handler	
.org 0x0028 jmp INTERRUPT_ERROR ; jmp EE_RDY 		; EEPROM Ready Handler			
.org 0x002A jmp INTERRUPT_ERROR ; jmp SPM_RDY 	; SPM Ready Handler					
.org 0x002C jmp INTERRUPT_ERROR ; jmp LCD_SOF 	; LCD Start of Frame Handler		
;-------------------------------------------------------------------------------
INTERRUPT_ERROR:
	ldi temp1,(ERROR_INTERRUT)
	rjmp ANZEIGE_ERROR_SCHWER_TEMP1
;-------------------------------------------------------------------------------
RESET:                        
; STACK initialisieren								
	ldi temp, LOW(RAMEND)
    out SPL, temp
    ldi temp, HIGH(RAMEND)
    out SPH, temp
;-------------------------------------------------------------------------------
	call WDR_INITIALISIERUNG
	call PORT_CLEAR
	call REGISTER_CLEAR
	call SRAM_CLEAR
	call STARTWERTE
	call LCD_INITIALISIERUNG
	call NEUSTART_MIT_WDR		; Neustart
	call TIMER0_INITIALISIEREN	; 2ms
	call TIMER2_INITIALISIEREN	; 2s 
	call LED_INITIALISIERUNG
	call MOTOR_INITIALISIERUNG
	call TASTEN_INITIALISIEREN
	call DREHGEBER_INITIALISIEREN
	call SLEEP_INITIALISIEREN
	call SLEEP_REFRESH
	call EEPROM_KONFIGURATION_LADEN
	call PROGRAMM_CHECK
;-------------------------------------------------------------------------------
	SEI
	call LCD_VOLL
	call MOTOR_BEEP_SPEZIAL
	call WAIT_50ms
	call MOTOR_BEEP_SPEZIAL
	call ADC_MESSEN_TEMPERATUR	
	call ADC_MESSEN_BATTERIE_SPANNUNG
	call LCD_CLEAR
	call MOTOR_POSITIONIEREN
;-------------------------------------------------------------------------------
LOOP:
	WDR
	call ACTION_ss
	call ACTION_mm
	call ACTION_MENUE_SLEEP
rjmp LOOP
; ##############################################################################
; ##############################################################################
; ##############################################################################
ACTION_MENUE_SLEEP:
	; Drehgeber on						
	call DREHGEBER_INITIALISIEREN
	; MOTOR REFLEXLICHTSCHRANKE ON ?	
	LDS temp,(adr_MOTOR_REFLEXLICHTSCHRANKE_ON)
	tst temp
	brne ACTION_MENUE	; ja
;-------------------------------------------------------------------------------
; DREHGEBER Kanal-A-B abfragen													
ACTION_MENUE_w:
	clr temp
	sbis (DREH_A_PIN),(DREH_A_PIN_NR)	; springe, wenn BIT(PIN) high	
	sbr temp,1 
	sbis (DREH_B_PIN),(DREH_B_PIN_NR)	; springe, wenn BIT(PIN) high	
	sbr temp,2 
	LDS temp1,(adr_DREHGEBER_OLD)		; OLD laden						
	cp temp,temp1
	breq ACTION_MENUE_w1				; keine DREHGEBER BEWEGUNG		
	STS(adr_DREHGEBER_OLD),temp			; OLD save						
	call SLEEP_REFRESH
	rjmp ACTION_MENUE
;-------------------------------------------------------------------------------
ACTION_MENUE_w1:
	LDS temp,(adr_TIMER_SLEEP)
	tst temp 
	brne ACTION_MENUE
;-------------------------------------------------------------------------------
	call DREHGEBER_OFF
	call MENUE
	STS(adr_LCD0),NULL
	STS(adr_MENUE),NULL
	call LCD_ZIFFERN_WRITE
	call POWER_REDUCTION
	SLEEP
	call POWER_REDUCTION_OFF
ret
;-------------------------------------------------------------------------------
ACTION_MENUE:
	call MENUE
	call WAIT_50ms	; unterdrckt flimmern
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ACTION_ss:
	LDS temp,(adr_FREIGABE_ss)
	STS(adr_FREIGABE_ss),NULL
	tst temp
	brne PC+2
	ret
;-------------------------------------------------------------------------------
	LDS temp,(adr_MENUE)	; MENUE geffnet	?	
	tst temp
	breq PC+2
	ret
;-------------------------------------------------------------------------------
	call PROGRAMM_CHECK	
	call HZG_SCHALTEN
	call BERECHNUNG
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
ACTION_mm:
	LDS temp,(adr_FREIGABE_mm)
	STS(adr_FREIGABE_mm),NULL
	tst temp
	brne PC+2
	ret
;-------------------------------------------------------------------------------
	call FUNCTION_HISTORIE_WRITE
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
.include "H_ADC.asm"
.include "H_BERECHNUNG.asm"
.include "H_EEPROM.asm"
.include "H_LCD_DEF.asm"
.include "H_LCD.asm"
.include "H_LCD_ANZEIGE.asm"
.include "H_LCD_BARGRAPH.asm"
.include "H_LCD_TEXT.asm"
.include "H_MENUE.asm"
.include "H_MOTOR.asm"
.include "H_TASTEN.asm"
.include "H_TIMER.asm"
.include "H_SONSTIGES.asm"
.include "H_WAIT_01MHZ.asm"




